;File Name        : NoMouse01.as
;Version 	  : 0.1 
;Last Up Date     : 2006/04/24
;Program Language : HSP Ver. 2.6 (http://www.onionsoft.net/hsp/)
;Author           : Tomohiko Sato
;URL1 : http://www.vector.co.jp/vpack/browse/person/an038336.html (Japanese)
;URL2 : http://www.hi5.com/friend/displayProfile.do?userid=35985557 (English)
;Comment : Contorol with Tenkey as Mouse.

#include "llmod.as" ; for mouse_event
#include "input.as" ; for mouse_event

#define PROGNAME "No_Mouse" 		; Program name
#define PROGVER  "0.1"			; Program version
#define PROGAUTHOR  "Tomohiko Sato"	; Program author
#define PROG_RUN curdir + "\\" 		; This Program Running path
#define TITL PROGNAME + " " 		; Window Title
#define SCR0X 250 			; Window screen ID=0 X size
#define SCR0Y 200 			; Window screen ID=0 Y size
	
	
;============================
; Set Window
;============================
	screen 0, SCR0X, SCR0Y, 0
	cls 1 ; gray
	title TITL+"Ver."+PROGVER

;============================
;Set default value
;============================
	mes "+---+-+---+ Tenkey '/' : Left"
	mes "| / |*| - | Tenkey '*' : Middle"
	mes "+---+-+---+ Tenkey '-' : Right"
	mes "|    8    | Tenkey '2' : "
	mes "| 4     6 | Tenkey '4' : "
	mes "|    2    | Tenkey '6' : "
	mes "+---------+ Tenkey '8' : "
	mes "  Fig. Mouse and Tenkey "
	mes "  Author : Tomohiko Sato"

	MC_Drag =45	;Drag(Keep selected mouse click   )  [Insert]=45
	MC_Drop =46	;Drop(Destroy selected mouse click)  [Delete]=46

	Cursor_Down  = 98 	;  Tnekey'2'=  98
	Cursor_Left  =100 	;  Tnekey'4'= 100
	Cursor_Right =102 	;  Tnekey'6'= 102
	Cursor_Up    =104 	;  Tnekey'8'= 104

	MC_One    = 101 	; Tenkey'5'=101
	MC_Double = 107		; Tenkey'+'=107

	MC_Left   = 111  ; Tenkey '/' = 111
	MC_Middle = 106  ; Tenkey '*' = 106
	MC_Right  = 109  ; Tenkey '-' = 109

;============================
;Set Object
;============================

	pos 95, 170 : button "Exit", *Prog_End ; Obj ID=0


;/*======================
;Main Loop
;========================
*main
	await 10 	; Delay Time

	movx=0 : movy=0
	getkey a,  Cursor_Down 	: if a : movy+	; Tnekey'2'=  98
	getkey a, Cursor_Left 	: if a : movx-	; Tnekey'4'= 100
	getkey a, Cursor_Right 	: if a : movx+	; Tnekey'6'= 102
	getkey a, Cursor_Up 	: if a : movy-	; Tnekey'8'= 104

	;[Left]
	;Push Down '/' Then Push Down Mouse Left 
	;MC_Left   = 111  ; Tenkey '/' = 111
	getkey kMC_Left, MC_Left
	if kMC_Left : a=$2 : else a=0
	await 5
	mouse_event $1+a, movx, movy
	;Keep Push Down '/' Then Pull Up Mose Left 
	if kMC_Left : mouse_event $4


	;[Middle]
	;Push Down '*' Then Push Down Mouse Middle
	;MC_Middle   = 106  ; Tenkey '*' = 106
	getkey kMC_Middle, MC_Middle
	if kMC_Middle : a=$20 : else a=0
	await 5
	mouse_event $1+a, movx, movy

	;Keep '*' Then Pull Up Mouse Middle
	if kMC_Middle : mouse_event $40

	;[Right]
	;Push Down '-' Then Push Down Mouse Right
	;MC_Right   = 109  ; Tenkey '-' = 109
	getkey kMC_Right, MC_Right : if kMC_Right : a=$8 : else a=0
	await 5
	mouse_event $1+a, movx, movy
	;Keep Push Down '-' Then Pull Up Mouse Right
	if kMC_Right : mouse_event $10

	goto *main
;=======================*/
stop


;/*======================
; Excute
;========================




stop


*Prog_End
	dialog "Exit this program ?", 3, "Alart : Exit?"
	if stat = 6 : end 			; stat : Yes=6, No=7
	if stat = 7 : goto *main
End

;========================
;Subrouthin
;========================
