;File Name        : HSPsource.as
;Last Up Date     : 2006/04/24
;Program Language : HSP Ver. 2.6 (http://www.onionsoft.net/hsp/)
;Author           : Tomohiko Sato
;URL1 : http://www.vector.co.jp/vpack/browse/person/an038336.html (Japanese)
;URL2 : http://www.hi5.com/friend/displayProfile.do?userid=35985557 (English)
;Comment :  

#include "Srexhsp.as" 	; for mevent

#include "llmod.as" ; for mouse_event
#include "input.as" ; for mouse_event

#define PROGNAME "Progname" 		; Program name
#define PROGVER  "0.1"			; Program version
#define PROGAUTHOR  "Tomohiko Sato"	; Program author
#define PROG_RUN curdir + "\\" 		; This Program Running path
#define TITL PROGNAME + " " 		; Window Title
#define SCR0X 600 			; Window screen ID=0 X size
#define SCR0Y 200 			; Window screen ID=0 Y size
	
	
;============================
; Set Window
;============================
screen 0, SCR0X, SCR0Y, 0
cls 1 ; gray
title TITL

;============================
;Set default value
;============================

	mes_SelL= "Selected Left"
	mes_SelM= "Selected Middle"
	mes_SelR= "Selected Right"
	mes_L1C= "Left 1 Click"
	mes_M1C= "Middle 1 Click"
	mes_R1C= "Right 1 Click"
	mes_L2C= "Left 2 Click"
	mes_M2C= "Middle 2 Click"
	mes_R2C= "Right 2 Click"
	mes_LPR = "Left Pull Up"
	mes_MPU = "Middle Pull Up"
	mes_RPU = "Right Pull Up"
	mes_Drp= "Drop(All Key Pull Up)"


	;/*--- Key Code ---
	;[Key Code for mouse_event, getkey]
	MC_Drag =45	;Drag(Keep selected mouse click   )  [Insert]=45
	MC_Drop =46	;Drop(Destroy selected mouse click)  [Delete]=46

	Cursor_Down  = 98 	;  Tnekey'2'=  98
	Cursor_Left  =100 	;  Tnekey'4'= 100
	Cursor_Right =102 	;  Tnekey'6'= 102
	Cursor_Up    =104 	;  Tnekey'8'= 104

	MC_One    = 101 	; Tenkey'5'=101
	MC_Double = 107		; Tenkey'+'=107

	MC_Left   = 111  	; Tenkey '/' = 111
	MC_Middle = 106  	; Tenkey '*' = 106
	MC_Right  = 109  	; Tenkey '-' = 109
	;--- Key Code ---*/

	;/*--- Flg ---
	; [Default Mouse Selected Flg]
	LeftSel_flg=0 		; Left Selected Flg
	MiddleSel_flg=0 	; Middle Selected Flg
	RightSel_flg=0 		; Right Selected Flg

	; [Default Mouse 1, 2 Click Flg]
	MC_One_flg=0 		; Mouse 1 click Flg
	MC_Double_flg=0 	; Mouse 2 click Flg

	;[Default Mouse Drag, Drop Flg]
	Drag_flg=0 : Drop_flg=0

	;[Tasktray In Flg]
	TaskIn_flg=0
	;*/--- Flg ---


;============================
;Set Object
;============================
	objsize 200, 25
	button "Left Mouse 1 Click", *L1C
	button "Left Mouse 2 Click", *L2C
	button "Left Mouse Push/Drag", *LKPD
	button "Left Mouse Pull Up/Drop", *LPU
	button "Exit", *Prog_End

;/*======================
;Main Loop
;========================
*main
;[Select]
;Drag =>
;1Click =>
;2Click =>
repeat
	await 15 	; Delay Time
	gosub *Sub_Move

	getkey kMC_Left, MC_Left
	if kMC_Left==1 : LeftSel_flg=1 : title mes_SelL+" Drag="+Drag_flg


	getkey kMC_One, MC_One
	if kMC_One==1 : MC_One_flg=1
	if (LeftSel_flg==1)&(MC_One_flg==1) : gosub *L1C

	getkey kMC_Double, MC_Double
	if kMC_Double==1 : MC_Double_flg=1
	if (LeftSel_flg==1)&(MC_Double_flg==1) : gosub *L2C

	getkey kMC_Drag, MC_Drag
	if kMC_Drag==1 : Drag_flg=1

	if (Drag_flg==1)&(LeftSel_flg==1) : goto *LeftDrag

	;title "a="+a+ ", Drag_flg="+Drag_flg + ", cnt="+cnt

	gosub *Sub_Drop
loop

*LeftDrag
;[Excute Drag]
if (LeftSel_flg==1)&(Drag_flg==1){
	repeat
		;gosub *Sub_Move	
		;a=$2

		movx=0 : movy=0
		getkey a, Cursor_Down 	: if a : movy+	; Tnekey'2'=  98
		getkey a, Cursor_Left 	: if a : movx-	; Tnekey'4'= 100
		getkey a, Cursor_Right 	: if a : movx+	; Tnekey'6'= 102
		getkey a, Cursor_Up 	: if a : movy-	; Tnekey'8'= 104
		if a==1 : a=0
		mouse_event $1+$2, movx, movy
		wait 2
		;M_Left=1
		;keybd_event  M_Left, 0
		;gsel 0, -1

		pset mousex, mousey
		gosub *Sub_Drop
		if Drop_flg==1 : Drop_flg=0 : keybd_event  M_Left, 1 : break
		title "a="+a+ ", Drag_flg="+Drag_flg + ", cnt="+cnt +"x="+mousex+", y="+mousey
		await 15
	loop
	LeftSel_flg=0 : Drag_flg=0 : Drop_flg=0 : MC_One_flg=0 : MC_Double_flg=0 
}

;stop

goto *main




;=======================*/
stop


;/*======================
; Excute
;========================


;goto *main

*LKPD
   	mouse_posx=200
	mouse_posy=200
	INS=45
	DEL=46
	dialog "Push [Insert] key, Draw Line."
   repeat
	getkey kINS, INS
	if kINS : break
	getkey kDEL, DEL
	if kDEL : goto *LPU
	title "[Insert] >Draw Line Start, [Delete] > Break"
	wait 2
   loop      

   repeat
	mevent 0, mouse_posx, mouse_posy 	 ;0 Left Push Down Keep
	pset mouse_posx, mouse_posy 			;1 Dot Line
	mouse_posx += 1
	mouse_posy += 0
	title "Draw x="+ mouse_posx+", y="+mouse_posy + ", [Delete] > Break"
	getkey kDEL, DEL
	if kDEL : break      
	wait 2
   loop
	msgetpos mouse_pos
	mouse_posx=mouse_pos.0
	mouse_posy=mouse_pos.1
	mevent 1, mouse_posx, mouse_posy 	;1 Left Pull Up
goto *main


*LPU
	msgetpos mouse_pos
	mouse_posx=mouse_pos.0
	mouse_posy=mouse_pos.1
	title "x="+ mouse_posx+", y="+mouse_posy
	mevent 1, mouse_posx, mouse_posy 	;1 Left Pull Up
goto *main
stop


*Prog_End
	dialog "Exit this program ?", 3, "Alart : Exit?"
	if stat = 6 : end 			; stat : Yes=6, No=7
	if stat = 7 : goto *main
End

;========================
;Subrouthin
;========================
*Sub_Move
	movx=0 : movy=0
	getkey a, Cursor_Down 	: if a : movy+	; Tnekey'2'=  98
	getkey a, Cursor_Left 	: if a : movx-	; Tnekey'4'= 100
	getkey a, Cursor_Right 	: if a : movx+	; Tnekey'6'= 102
	getkey a, Cursor_Up 	: if a : movy-	; Tnekey'8'= 104
	;if (Drag_flg==1)&(LeftSel_flg) : a=$2
 	;if (Drop_flg==1)&(LeftSel_flg) : a=$4
	if a==1 : a=0
	mouse_event $1+a, movx, movy
	;title "a="+a+", movx="+movx+", movy"+movy
return

*L1C 
	;mevent 6, 0, 0    ;6 Left 1 click
repeat 1
	mouse_event $1+$2, movx, movy
	pset mousex, mousey
	wait 30
	mouse_event $1+$4, movx, movy
	Cl=cnt+1
	title "Left 1 Click "+ Cl
loop
Drag_flg=0 : LeftSel_flg=0 :  MC_One_flg=0 : MC_Double_flg=0 : Drop_flg=0
return

*L2C
	;mevent 8, 0, 0    ;8 Left 2 click
repeat 2
	mouse_event $1+$2, movx, movy
	pset mousex, mousey
	wait 30
	mouse_event $1+$4, movx, movy
	Cl=cnt+1
	title "Left 2 Click "+ Cl
loop
Drag_flg=0 : LeftSel_flg=0 :  MC_One_flg=0 : MC_Double_flg=0 : Drop_flg=0
return


*Sub_Drop
	getkey kMC_Drop, MC_Drop
	if kMC_Drop ==1 {
		Drop_flg=1
		LeftSel_flg=0 : MC_One_flg=0 : MC_Double_flg=0
		title mes_Drp
	}
return